<template>
	<div ref="compEl">
		<client-only>
			<template v-if="SUBSCRIPTIONS.length && viewState === 'show_filter' && !activateRefill">
				<div
					v-if="dateRenewalSuccess"
					class="h-14 px-6 w-full bg-mint-20 md:rounded-t-lg lg:rounded-t-lg flex items-center text-base font-primary-font-regular"
				>
					Your renewal date has been updated to {{ selectedDay | formatDateAurora }}
				</div>
				<div
					v-if="turnOffSuccess"
					class="h-14 px-6 w-full bg-error-10 md:rounded-t-lg lg:rounded-t-lg flex items-center text-base font-primary-font-regular"
				>
					Auto-refills are turned off.
				</div>
				<div
					v-if="showSuccess"
					class="h-14 px-6 w-full bg-mint-20 md:rounded-t-lg lg:rounded-t-lg flex items-center text-base font-primary-font-regular"
					role="alert"
				>
					Thank you for the update.
				</div>
				<MkRefillsProduct
					v-for="(item, i) in subscriptionOrder"
					:key="item.key"
					ref="edit_button"
					:row-index="i"
					:subscription-item="item"
					:selected-subscription="selectedSubscriptionData"
					:show-success="showSuccess"
					:turn-off-success="turnOffSuccess"
					:date-renewal-success="dateRenewalSuccess"
					@set-focus="($value) => (currentIndex = $value)"
					@emitted-event="changeViewState"
					@subscription-select="subscriptionSelect"
				/>
				<div class="bg-white md:rounded-lg lg:rounded mt-2 md:mt-6 lg:mt-2 py-4 lg:py-6">
					<MkPageNavigation
						v-if="subscriptionOrder.length > 0"
						:pages="calculateVisibleSubscription"
						@click="showOrders($event)"
					/>
				</div>
			</template>
			<MkRefillsPay
				v-else-if="['edit_payment', 'edit_shipping'].indexOf(viewState) > -1"
				:data-obj="componentProps"
				@emitted-event="changeViewState"
			/>
			<MkTurningOffAutoRefills
				v-else-if="viewState === 'turn_off'"
				:selected-subscription="selectedSubscriptionData"
				@emitted-event="changeViewState"
			/>
			<MkRefillsShipping
				v-if="activateRefill"
				:subscription-selected="subscriptionSelected"
				@subscription-turned-on="subscription_turnedOn"
			/>
			<MkModal
				:toggle-modal="showPopup && showCalendar"
				:focus-close="focusClose"
				:modal-heading="'Select new renewal date'"
				model-class=" max-w-full md:max-w-md lg:max-w-xl"
				modal-style="mx-0 p-15px"
				modal-height="h-full"
			>
				<template #modalHeader>
					<h1 class="font-secondary-font-regular text-2xl lg:text-base2 leading-tight"> Select new renewal date </h1>
				</template>
				<template #modalContent>
					<div class="flex mt-8 px-2 md:p-0 lg:p-0">
						<p class="w-44 mr-4 text-base md:text-xs lg:text-base leading-6 font-primary-font-bold">
							Current renewal date
						</p>
						<p class="text-base font-primary-font-light">
							{{ selectedSubscriptionData.nextOrderDate | formatDateAurora }}
						</p>
					</div>
					<div class="flex mb-6 md:mb-25px px-2 md:p-0 lg:p-0">
						<p class="w-44 mr-4 text-base md:text-xs lg:text-base leading-6 font-primary-font-bold">
							New renewal date
						</p>
						<p v-if="selectedDay" class="text-base font-primary-font-light">
							{{ selectedDay | formatDateAurora }}
						</p>
						<p v-else class="text-base font-primary-font-light">Select date</p>
					</div>
					<p class="text-base font-primary-font-light mb-6 md:mb-10 lg:mb-10 py-0 px-2 md:p-0 lg:p-0">
						The billing period for your refill plan will begin on this date.
					</p>
					<div class="border-b border-grey-20"></div>
					<div class="w-full mt-6 md:mt-25px lg:mt-25px">
						<v-calendar
							v-model="date"
							:attributes="attributes"
							:first-day-of-week="1"
							disabled
							:available-dates="avaliableDates"
							:disabled-dates="disableDates"
							class="custom-calendar"
							aria-label="calendar"
							:from-page="{
								month: moveMonth.getMonth() + 1,
								year: moveMonth.getFullYear(),
							}"
							@dayclick="onClickDate($event)"
						/>
					</div>
					<div class="flex flex-col justify-center items-center mt-2">
						<MkPrimaryButton
							tabindex="0"
							:disabled="buttonDisabled"
							:loading="loading"
							btn-class=" w-44 h-10 py-2 px-8 focus:ring align-middle font-primary-font-light"
							button-title="Change date"
							@click="saveDate()"
							@keydown.enter="saveDate()"
						/>
						<button
							class="font-primary-font-bold text-base cursor-pointer mt-6 focus:outline-none focus:ring-1 focus:ring-black"
							@keydown="focusToCloseField($event)"
							@click="
								cancelModal;
								$store.commit('MODAL_STORE/TOGGLE_MODAL');
							"
						>
							Cancel
						</button>
					</div>
				</template>
			</MkModal>
		</client-only>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import Vue from 'vue';
import VCalendar from 'v-calendar';
import MkRefillsShipping from '~/components/D2C/organisms/MkRefillsShipping.vue';
import MkRefillsProduct from '~/components/D2C/molecules/MkRefillsProduct.vue';
import MkRefillsPay from '~/components/D2C/molecules/MkRefillsPay.vue';
import MkTurningOffAutoRefills from '~/components/D2C/molecules/MkTurningOffAutoRefills.vue';
import MkModal from '~/components/D2C/molecules/MkModal.vue';
import MkPageNavigation from '~/components/D2C/atoms/MkPageNavigation.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
Vue.use(VCalendar);

export default {
	name: 'AutoRefills',
	components: {
		MkRefillsShipping,
		MkRefillsProduct,
		MkRefillsPay,
		MkTurningOffAutoRefills,
		MkModal,
		MkPageNavigation,
		MkPrimaryButton,
	},
	layout: 'aurora-layout',
	data() {
		return {
			viewState: 'show_filter',
			componentProps: {
				action: 'shipping',
			},
			selectedSubscriptionData: {},
			showCalendar: false,
			date: new Date(),
			selectedDay: null,
			attributes: [
				{
					highlight: {
						color: 'black',
						style: {
							backgroundColor: 'black',
						},
						contentStyle: {
							color: 'white',
							fontStyle: 'normal',
							fontWeight: 'normal',
						},
						fillMode: 'light',
						order: 0,
					},
					dates: new Date(),
				},
			],
			fetchingData: false,
			activateRefill: false,
			subscriptionSelected: {},
			pages: {
				pageNo: [1],
				currentPage: 1,
			},
			totalPages: 1,
			subscriptionOrder: [],
			viewCount: 10,
			loading: false,
			disabled: true,
			nextDate: '',
			startDate: new Date(),
			moveMonth: new Date(),
			endDate: null,
			avaliableDates: '',
			disableDates: '',
			buttonDisabled: true,
			dateRenewalSuccess: false,
			turnOffSuccess: false,
			showSuccess: false,
			focusClose: false,
			currentIndex: { index: 0, from: '' },
			initialFocus: true,
			initialIndex: 0,
		};
	},
	head() {
		return {
			title: 'Auto Refills',
		};
	},
	computed: {
		...mapState('USER_STORE', ['SUBSCRIPTIONS', 'AUTHENTICATED']),
		...mapState('CHECKOUT_STORE', ['SHOW_PAGE_SPINNER']),

		showPopup() {
			return this.$store.state.MODAL_STORE.IS_ACTIVE;
		},
		calculateVisibleSubscription() {
			this.handelTable();
			return this.pages;
		},
	},
	watch: {
		SUBSCRIPTIONS() {
			if (this.SUBSCRIPTIONS && !this.SUBSCRIPTIONS.errorMessage) {
				this.subscriptionOrder = [...this.SUBSCRIPTIONS];
				this.setTooltipFocus();
			}
		},
		AUTHENTICATED() {
			if (this.AUTHENTICATED) {
				this.getSubscription();
			}
		},
		selectedDay: {
			deep: true,
			handler() {
				if (this.selectedDay) {
					this.buttonDisabled = false;
				} else {
					this.buttonDisabled = true;
				}
			},
		},
	},
	beforeMount() {
		this.fetchingData = true;
	},
	mounted() {
		if (this.AUTHENTICATED) {
			this.getSubscription();
		}
	},
	methods: {
		setTooltipFocus() {
			if (this.initialFocus && this.SUBSCRIPTIONS.length) {
				const focusRow = this.initialIndex;
				this.$nextTick().then(() => {
					const index = focusRow + 'tooltip';
					this.$refs.edit_button[focusRow].$refs[index].focus();
				});
				this.initialFocus = false;
			}
		},
		async getSubscription() {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', {});
			this.fetchingData = false;
			await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
		},
		setFocus(value) {
			const focusRow = this.currentIndex.index;
			if (this.currentIndex.from === 'edit_shipping') {
				this.$nextTick().then(() => {
					const index = focusRow + this.currentIndex.from;
					this.$refs.edit_button[focusRow].$refs[index].focus();
				});
			} else {
				this.$nextTick().then(() => {
					const index = focusRow + this.currentIndex.from;
					this.$refs.edit_button[focusRow].$refs[index].focus();
				});
			}
		},
		async changeViewState(event, value) {
			if (event === 'edit_payment') {
				this.viewState = event;
				this.componentProps = {
					action: 'payment',
					selectedSubscription: value,
				};
			} else if (event === 'edit_shipping') {
				this.viewState = event;
				this.componentProps = {
					action: 'shipping',
					selectedAddress: value.shippingAddress,
					selectedSubscription: value,
				};
			} else if (event === 'cancel') {
				this.setFocus();
				this.viewState = 'show_filter';
			} else if (event === 'change_renewal') {
				this.selectedDay = null;
				this.selectedSubscriptionData = value;
				const newDate = new Date(this.selectedSubscriptionData.nextOrderDate);
				this.date = new Date(this.selectedSubscriptionData.nextOrderDate);
				const $next = this.date;
				const $current = new Date();
				const d1 = new Date($current.getFullYear() + '/' + ($current.getMonth() + 1) + '/' + $current.getDate()); // .setDate($current.getDate()))
				const d2 = new Date($next.getFullYear() + '/' + ($next.getMonth() + 1) + '/' + $next.getDate());
				let $startDate;
				let $endDate;
				if (Date.parse(d1) >= Date.parse(d2)) {
					this.disableDates = { start: null, end: null };
					this.moveMonth = new Date($next.setDate($next.getDate()));
					this.avaliableDates = null;
					this.attributes[0].highlight.style.backgroundColor = '#e5e7eb';
				} else {
					$startDate = new Date(newDate.setDate(newDate.getDate()));
					$endDate = new Date(newDate.setFullYear(newDate.getFullYear() + 1));
					this.moveMonth = new Date($next.setDate($next.getDate()));
					this.disableDates = null;
					this.avaliableDates = { start: $startDate, end: $endDate };
					this.attributes[0].dates = $next;
				}
				this.showCalendar = true;
				setTimeout(() => {
					this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
				}, 200);
			} else if (event === 'turn_off') {
				this.viewState = event;
				this.selectedSubscriptionData = value;
			} else if (event === 'update_payment') {
				this.viewState = 'edit_payment';
				this.componentProps = {
					action: 'update_payment',
					infoObj: value.infoObj,
					selectedSubscription: value,
					cardDetails: value.cardDetails && value.cardDetails.brand ? value.cardDetails : null,
				};
			} else if (event === 'turn-off-success') {
				await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', {});
				this.viewState = 'show_filter';
				this.showTurnoffSuccessMsg();
			}
			if (event !== 'cancel' && event !== 'change_renewal' && event !== 'turn-off-success' && event === 'saved') {
				this.viewState = 'show_filter';
				this.showThankyouMsg();
				this.setFocus();
			}
			window.scrollTo(0, this.$refs.compEl.offsetTop - 300);
		},

		onClickDate(e) {
			if (new Date(this.date) !== new Date()) {
				if (!e.isDisabled) {
					this.$set(this.attributes[0].highlight.style, 'backgroundColor', 'transparent');
					this.$set(this.attributes[0].highlight, 'fillMode', 'outline');
					this.$set(this.attributes[0].highlight.contentStyle, 'color', 'black');
					this.$set(this.attributes, 1, {
						highlight: {
							color: 'black',
							fillMode: 'light',
							style: {
								backgroundColor: 'black',
							},
							contentStyle: {
								color: 'white',
								fontStyle: 'normal',
								fontWeight: 'normal',
							},
						},
						dates: e.date,
					});
					this.moveMonth = e.date;
				} else {
					return;
				}
				this.selectedDay = e.date.toLocaleDateString('en-US');
				this.disabled = false;
			}
		},
		async saveDate() {
			try {
				let $data = {};
				if (this.selectedDay) {
					this.loading = true;
					$data = {
						container: this.selectedSubscriptionData.container,
						key: this.selectedSubscriptionData.key,
						data: {
							action: 'UPDATE_RENEWAL_DATE',
							renewalDate: this.$options.filters.formatDateAurora(this.selectedDay, 'YYYY-MM-DD'),
						},
					};
				}
				await this.$store.dispatch('USER_STORE/UPDATE_SUBSCRIPTION_QUANTITY', $data);
				await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', {});
				this.showCalendar = false;
				this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
				this.loading = false;
				this.showSuccessMsg();
				this.buttonDisabled = true;
			} catch (exp) {
				this.loading = false;
			}
		},
		showOrders(val) {
			let selectedVal = 1;
			if (val && val.target) {
				if (val.target.textContent) {
					selectedVal = val && val.target && parseInt(val.target.textContent);
				} else if (val.target.id === 'first') {
					selectedVal = 1;
				} else if (val.target.id === 'last') {
					selectedVal = this.totalPages;
				}
			}
			const totalCount = this.viewCount;
			const tempVal = [...this.SUBSCRIPTIONS];
			const maxVal = selectedVal * totalCount;
			const minVal = maxVal - totalCount;
			this.$set(this.pages, 'currentPage', selectedVal);
			this.subscriptionOrder = tempVal.slice(minVal, maxVal);
			this.$forceUpdate();
		},
		subscriptionSelect(data) {
			this.subscriptionSelected = data;
			this.activateRefill = true;
		},
		cancelModal() {
			this.showCalendar = false;
			this.selectedDay = null;
		},
		async subscription_turnedOn() {
			this.subscriptionSelected = {};
			await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', {});
			this.activateRefill = false;
			this.showThankyouMsg();
		},
		showTurnoffSuccessMsg() {
			this.turnOffSuccess = true;
			const $parent = this;
			setTimeout(function () {
				$parent.turnOffSuccess = false;
			}, 3000);
		},
		showSuccessMsg() {
			this.dateRenewalSuccess = true;
			const $parent = this;
			setTimeout(function () {
				$parent.dateRenewalSuccess = false;
			}, 3000);
		},
		showThankyouMsg() {
			this.showSuccess = true;
			const $parent = this;
			setTimeout(function () {
				$parent.showSuccess = false;
			}, 3000);
		},
		focusToCloseField(e) {
			if (e.keyCode === 9) {
				if (e.shiftKey) {
					// shiftkey will be undefined
				} else {
					e.preventDefault();
					this.focusClose = true;
					const self = this;
					setTimeout(function () {
						self.focusClose = false;
					}, 200);
				}
			}
		},
		handelTable() {
			const numOfSubscription = this.SUBSCRIPTIONS && this.SUBSCRIPTIONS.length;
			if (numOfSubscription > this.viewCount) {
				this.pages.pageNo = [];
				this.showOrders();
				const pageNo = numOfSubscription / this.viewCount;
				this.totalPages = Math.floor(pageNo) + 1;

				if (pageNo % 1 === 0) {
					this.totalPages = pageNo;
				}

				for (let i = 1; i <= this.totalPages; i++) {
					this.pages.pageNo.push(i);
				}
			}
		},
	},
};
</script>
<style lang="postcss" scoped>
.icon-close::before {
	@apply text-black text-lg;
}
/deep/ .custom-calendar.vc-container {
	@apply w-full border-none;
	&.vc-title {
		@apply font-primary-font-bold text-black text-base font-normal;
	}
	&.vc-weekday {
		@apply font-primary-font-regular text-black text-base font-normal py-6 hover:bg-transparent;
	}
	&.vc-day-content {
		@apply w-10 h-10;
	}
	&.vc-highlight {
		@apply w-10 h-10 bg-black;
	}
}
</style>
